package demo.barcharts.category ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class BarChart3DDemo2 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.HORIZONTAL ;

  public BarChart3DDemo2() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel() ;
  }

  private void addPanel() {
    final IMatrixDataset dataset = createDataset() ;
    final IJChart chart = ChartFactory.createCategoryBar3DChart(
      "3D Bar Chart Demo 2", "Category", "Value", dataset, orientation, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.setDomainGridlineVisible(false) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("London") ;
    dataset.addRowKey("New York") ;
    dataset.addRowKey("Istanbul") ;
    dataset.addRowKey("Cairo") ;

    for (int i = 1 ; i <= 3 ; i++) {
      dataset.addColKey("Series " + i) ;
    }

    double data[][] = { {23D, 14D, 14D, 14D}, {13D, 19D, 19D, 19D}, {7D, 9D, 9D, 9D}
    } ;
    dataset.addRowData(4) ;

    for (int i = 0 ; i < 4 ; i++) {
      for (int j = 0 ; j < data.length ; j++) {
        dataset.addData(i, new NumberChartData(data[j][i])) ;
      }
    }

    return dataset ;
  }

}
