package demo.dataset ;

import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class SampleXYDataset2 {
  private int rows, columns ;

  public SampleXYDataset2(int rows, int columns) {
    this.rows = rows ;
    this.columns = columns ;
  }

  public IMatrixDataset getDataset() {
    double d = (1.0D / 0.0D) ;
    double d1 = ( -1.0D / 0.0D) ;
    double d2 = (1.0D / 0.0D) ;
    double d3 = ( -1.0D / 0.0D) ;

    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowData(rows) ;
    for (int k = 0 ; k < rows ; k++) {
      dataset.addRowKey("Samples " + k) ;
      for (int m = 0 ; m < columns ; m++) {
        double d4 = (Math.random() - 0.5D) * 200D ;
        double x = d4 ;
        if (d4 < d) {
          d = d4 ;
        }
        if (d4 > d1) {
          d1 = d4 ;
        }

        double d5 = (Math.random() + 0.5D) * 6D * d4 + d4 ;
        double y = d5 ;
        if (d5 < d2) {
          d2 = d5 ;
        }
        if (d5 > d3) {
          d3 = d5 ;
        }

        dataset.addData(k, new XYNumberChartData(x, y)) ;
      }
    }

    return dataset ;
  }
}
