package demo.linecharts ;

import java.awt.BasicStroke ;
import java.awt.GridLayout ;
import java.awt.Polygon ;
import java.awt.Shape ;
import java.awt.geom.Rectangle2D ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.format.NumberChartDataFormatter ;
import com.ijchart.xychart.label.DefaultLabelGenerator ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.AbstractRender ;
import com.ijchart.xychart.tickunit.LongTickUnit ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class LineChartDemo5 extends JPanel {

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  private IMatrixDataset dataset = createDataset1() ;

  public LineChartDemo5() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IJChart chart = ChartFactory.createCategoryLineAndShapeChart(
      "Line Chart Demo 5", "Type", "Value", dataset, horizontal, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractRender render = plot.getRender() ;
    render.setLabelGenerator(new DefaultLabelGenerator(new NumberChartDataFormatter("#0.0"))) ;
    ((NumberValueAxis) plot.getValueAxis()).setTickUnit(new LongTickUnit()) ;

    Shape ashape[] = new Shape[3] ;
    int ai[] = { -3, 3, -3} ;
    int ai1[] = { -3, 0, 3} ;
    ashape[0] = new Polygon(ai, ai1, 3) ;
    ashape[1] = new java.awt.geom.Rectangle2D.Double( -2D, -3D, 3D, 6D) ;
    ai = (new int[] { -3, 3, 3}) ;
    ai1 = (new int[] {0, -3, 3}) ;
    ashape[2] = new Polygon(ai, ai1, 3) ;

    render.setRowItemBorderStroke(0, new BasicStroke(2.0F, 1, 1, 1.0F, new float[] {10F, 6F
    }, 0.0F)) ;
    render.setRowItemBorderStroke(1, new BasicStroke(2.0F, 1, 1, 1.0F, new float[] {6F, 6F
    }, 0.0F)) ;
    render.setRowItemBorderStroke(2, new BasicStroke(2.0F, 1, 1, 1.0F, new float[] {2.0F, 6F
    }, 0.0F)) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    double[][] values = { {1, 4, 3, 5, 5, 7, 7, 8}, {5, 7, 6, 8, 4, 4, 2, 1}, {4, 3, 2, 3, 6, 3, 4,
                        3}
    } ;
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("First") ;
    dataset.addRowKey("Second") ;
    dataset.addRowKey("Third") ;

    for (int i = 0 ; i < 3 ; i++) {
      dataset.addRowData() ;
      for (int j = 1 ; j <= 8 ; j++) {
        if (i == 0) {
          dataset.addColKey("Type " + j) ;
        }

        dataset.addData(i, new NumberChartData(values[i][j - 1])) ;
      }
    }

    return dataset ;
  }

}
