package demo.linecharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;
import com.ijchart.xychart.tickunit.LongTickUnit ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class LineChartDemo6 extends JPanel {

  private ChartOrientation horizontal = ChartOrientation.VERTICAL ;

  private IMatrixDataset dataset = createDataset1() ;

  public LineChartDemo6() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IJChart chart = ChartFactory.createXYLineAndShapeChart(
      "Line Chart Demo 6", "X", "Y", dataset, horizontal, true, true, false, false) ;

    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    XYLineAndShapeRender render = (XYLineAndShapeRender) xyplot.getRender() ;
    render.setRowItemLineVisible(0, false) ;
    render.setRowItemShapeVisible(1, false) ;

    XYNumberValueAxis domainaxis = (XYNumberValueAxis) xyplot.getDomainAxis() ;
    domainaxis.setTickUnit(new LongTickUnit()) ;
    domainaxis.setLowerMargin(0.02);
    domainaxis.setUpperMargin(0.02);

    XYNumberValueAxis numberaxis = (XYNumberValueAxis) xyplot.getValueAxis() ;
    numberaxis.setTickUnit(new LongTickUnit()) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("First") ;
    dataset.addRowKey("Second") ;
    dataset.addRowKey("Third") ;

    dataset.addRowData(3) ;
    dataset.addData(0, new XYNumberChartData(1.0D, 1.0D)) ;
    dataset.addData(0, new XYNumberChartData(2D, 4D)) ;
    dataset.addData(0, new XYNumberChartData(3D, 3D)) ;
    dataset.addData(0, new XYNumberChartData(4D, 5D)) ;
    dataset.addData(0, new XYNumberChartData(5D, 5D)) ;
    dataset.addData(0, new XYNumberChartData(6D, 7D)) ;
    dataset.addData(0, new XYNumberChartData(7D, 7D)) ;
    dataset.addData(0, new XYNumberChartData(8D, 8D)) ;

    dataset.addData(1, new XYNumberChartData(1.0D, 5D)) ;
    dataset.addData(1, new XYNumberChartData(2D, 7D)) ;
    dataset.addData(1, new XYNumberChartData(3D, 6D)) ;
    dataset.addData(1, new XYNumberChartData(4D, 8D)) ;
    dataset.addData(1, new XYNumberChartData(5D, 4D)) ;
    dataset.addData(1, new XYNumberChartData(6D, 4D)) ;
    dataset.addData(1, new XYNumberChartData(7D, 2D)) ;
    dataset.addData(1, new XYNumberChartData(8D, 1.0D)) ;

    dataset.addData(2, new XYNumberChartData(3D, 4D)) ;
    dataset.addData(2, new XYNumberChartData(4D, 3D)) ;
    dataset.addData(2, new XYNumberChartData(5D, 2D)) ;
    dataset.addData(2, new XYNumberChartData(6D, 3D)) ;
    dataset.addData(2, new XYNumberChartData(7D, 6D)) ;
    dataset.addData(2, new XYNumberChartData(8D, 3D)) ;
    dataset.addData(2, new XYNumberChartData(9D, 4D)) ;
    dataset.addData(2, new XYNumberChartData(10D, 3D)) ;

    return dataset ;
  }

}
