package demo.miscellaneous ;

import java.awt.BorderLayout ;
import java.awt.Color ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYZNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYBubbleRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class BubbleChartDemo1 extends JPanel {

  public BubbleChartDemo1() {
    setLayout(new BorderLayout()) ;
    createPanel1() ;
  }

  public void createPanel1() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createXYBubbleChart("Bubble Chart Demo 1", "X",
                                                     "Y", dataset, ChartOrientation.HORIZONTAL, true,
                                                     true, false, false) ;
    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    xyplot.setForegroundAlpha(0.65F) ;

    XYBubbleRender render = (XYBubbleRender) xyplot.getRender() ;
    render.setAutoSelectFillPaint(false) ;
    render.setRowItemFillPaint(0, Color.blue) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;
    dataset.addRowData() ;

    double ad[] = {2.1000000000000001D, 2.2999999999999998D, 2.2999999999999998D,
                  2.2000000000000002D, 2.2000000000000002D, 1.8D, 1.8D, 1.8999999999999999D,
                  2.2999999999999998D, 3.7999999999999998D
    } ;
    double ad1[] = {14.1D, 11.1D, 10D, 8.8000000000000007D, 8.6999999999999993D,
                   8.4000000000000004D, 5.4000000000000004D, 4.0999999999999996D,
                   4.0999999999999996D, 25D
    } ;
    double ad2[] = {2.3999999999999999D, 2.7000000000000002D, 2.7000000000000002D,
                   2.2000000000000002D, 2.2000000000000002D, 2.2000000000000002D,
                   2.1000000000000001D, 2.2000000000000002D, 1.6000000000000001D, 4D
    } ;

    for (int i = 0 ; i < ad.length ; i++) {
      dataset.addData(0, new XYZNumberChartData(ad[i], ad1[i], ad2[i])) ;
    }

    return dataset ;
  }

}
