package demo.miscellaneous.crosshairs;

import java.awt.BorderLayout ;
import java.awt.Color ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.ui.RectangleInsets ;
/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class CrosshairDemo4 extends JPanel {

  public CrosshairDemo4() {
    setLayout(new BorderLayout()) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset1 = createDataset() ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart("Crosshair Demo 4", "X",
                                                   "Y", dataset1, ChartOrientation.VERTICAL, true, false,
                                                   false, false) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    plot.setDomainGridlinePaint(Color.white) ;
    plot.setValueGridlinePaint(Color.white) ;
    plot.setAxisOffset (new RectangleInsets (5D, 5D, 5D, 5D)) ;

    plot.setDomainCrosshairVisible(true) ;
    plot.setValueCrosshairVisible(true) ;

    ChartPanel chartPanel = new ChartPanel(chart) ;
    add(chartPanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("First") ;
    dataset.addRowKey("Second") ;
    dataset.addRowKey("Third") ;
    dataset.addRowData(3) ;

    dataset.addData(0, new XYNumberChartData(1.0D, 1.0D)) ;
    dataset.addData(0, new XYNumberChartData(2D, 4D)) ;
    dataset.addData(0, new XYNumberChartData(3D, 3D)) ;
    dataset.addData(0, new XYNumberChartData(4D, 5D)) ;
    dataset.addData(0, new XYNumberChartData(5D, 5D)) ;
    dataset.addData(0, new XYNumberChartData(6D, 7D)) ;
    dataset.addData(0, new XYNumberChartData(7D, 7D)) ;
    dataset.addData(0, new XYNumberChartData(8D, 8D)) ;

    dataset.addData(1, new XYNumberChartData(1.0D, 5D)) ;
    dataset.addData(1, new XYNumberChartData(2D, 7D)) ;
    dataset.addData(1, new XYNumberChartData(3D, 6D)) ;
    dataset.addData(1, new XYNumberChartData(4D, 8D)) ;
    dataset.addData(1, new XYNumberChartData(5D, 4D)) ;
    dataset.addData(1, new XYNumberChartData(6D, 4D)) ;
    dataset.addData(1, new XYNumberChartData(7D, 2D)) ;
    dataset.addData(1, new XYNumberChartData(8D, 1.0D)) ;

    dataset.addData(2, new XYNumberChartData(3D, 4D)) ;
    dataset.addData(2, new XYNumberChartData(4D, 3D)) ;
    dataset.addData(2, new XYNumberChartData(5D, 2D)) ;
    dataset.addData(2, new XYNumberChartData(6D, 3D)) ;
    dataset.addData(2, new XYNumberChartData(7D, 6D)) ;
    dataset.addData(2, new XYNumberChartData(8D, 3D)) ;
    dataset.addData(2, new XYNumberChartData(9D, 4D)) ;
    dataset.addData(2, new XYNumberChartData(10D, 3D)) ;

    return dataset ;
  }

}
