package demo.others ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.SingleRowDataset ;
import com.ijchart.xychart.plot.NoAxisPlot ;
import com.ijchart.xychart.render.noaxis.PieRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class RingChartPanel3 extends JPanel {

  public RingChartPanel3() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    SingleRowDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createRingChart("Ring Chart Demo 1", dataset, true, true) ;
    NoAxisPlot plot = (NoAxisPlot) chart.getPlot() ;

    PieRender render = (PieRender) plot.getRender() ;
//    render.setPieRotation(Rotation.ANTICLOCKWISE) ;
    render.setExplodePercent(2, 0.1) ;
    render.setSimpleLabels(true) ;
//    render.setItemLabelVisible(0, 0, false) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;

    add(chartpanel) ;
  }

  private static SingleRowDataset createDataset() {
    SingleRowDataset volumeDataset = new SingleRowDataset() ;

    volumeDataset.addColKey("One") ;
    volumeDataset.addColKey("Two") ;
    volumeDataset.addColKey("Three") ;
    volumeDataset.addColKey("Four") ;
    volumeDataset.addColKey("Five") ;
    volumeDataset.addColKey("Six") ;
    volumeDataset.addColKey("Seven") ;

    volumeDataset.addRowData() ;
    volumeDataset.addData(0, new NumberChartData(43.200000000000003D)) ;
    volumeDataset.addData(0, new NumberChartData(10D)) ;
    volumeDataset.addData(0, new NumberChartData(27.5D)) ;
    volumeDataset.addData(0, new NumberChartData(17.5D)) ;
    volumeDataset.addData(0, new NumberChartData(11D)) ;
    volumeDataset.addData(0, new NumberChartData(19.399999999999999D)) ;
    volumeDataset.addData(0, null) ;

    return volumeDataset ;
  }

}
