package demo.others.common.renderer ;

import java.awt.Component ;
import java.text.NumberFormat ;

import javax.swing.JTable ;
import javax.swing.SwingConstants ;
import javax.swing.table.DefaultTableCellRenderer ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class NumberCellRenderer extends DefaultTableCellRenderer {
  public NumberCellRenderer() {
    setHorizontalAlignment(SwingConstants.RIGHT) ;
  }

  public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected,
                                                 boolean hasFocus, int row, int column) {

    setFont(null) ;
    final NumberFormat nf = NumberFormat.getNumberInstance() ;
    if (value != null) {
      setText(nf.format(value)) ;
    } else {
      setText("") ;
    }
    if (isSelected) {
      setBackground(table.getSelectionBackground()) ;
    } else {
      setBackground(null) ;
    }
    return this ;
  }
  }
