package demo.others.metercharts ;

import java.awt.BorderLayout ;
import java.awt.Color ;
import java.awt.GridLayout ;

import javax.swing.BorderFactory ;
import javax.swing.JPanel ;
import javax.swing.JSlider ;
import javax.swing.event.ChangeEvent ;
import javax.swing.event.ChangeListener ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.MeterShapeType ;
import com.ijchart.xychart.data.StartEndNumberChartData ;
import com.ijchart.xychart.dataset.SingleRowDataset ;
import com.ijchart.xychart.plot.NoAxisPlot ;
import com.ijchart.xychart.render.noaxis.MeterRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class MeterChartPanel3 extends JPanel {

  private IJChart chart = null ;

  public MeterChartPanel3() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    JPanel jpanel = new JPanel(new BorderLayout()) ;
    jpanel.setBorder(BorderFactory.createLineBorder(Color.red, 2)) ;

    JSlider jslider = new JSlider( -10, 110, 50) ;
    jslider.setMajorTickSpacing(10) ;
    jslider.setMinorTickSpacing(5) ;
    jslider.setPaintLabels(true) ;
    jslider.setPaintTicks(true) ;
    jpanel.add(BorderLayout.SOUTH, jslider) ;
    add(jpanel) ;

    jslider.addChangeListener(new ChangeListener() {
      public void stateChanged(ChangeEvent changeevent) {
        JSlider jslider1 = (JSlider) changeevent.getSource() ;
        if (chart != null) {
          NoAxisPlot noAxisPlot = (NoAxisPlot) chart.getPlot() ;
          MeterRender render = (MeterRender) noAxisPlot.getRender(0) ;
          render.setValue(jslider1.getValue()) ;
        }
      }
    }) ;

    SingleRowDataset dataset = createDataset() ;
    chart = ChartFactory.createMeterChart(
      "This is a very long title,it has many words and wrap automatically.",
      dataset, true, true) ;
    NoAxisPlot plot = (NoAxisPlot) chart.getPlot() ;
    MeterRender render = (MeterRender) plot.getRender() ;
    render.setValue(50.0) ;
    render.setBaseItemDrawBorder(true) ;
//    render.setBaseItemFill(false);
//    render.setBackgroundPaint(DefaultDrawingSupplier.DEFAULT_FILL_PAINT_SEQUENCE[0]) ;
    render.setMeterAngle(320) ;
    render.setMeterShapeType(MeterShapeType.PIE) ;

    ChartPanel chartPanel = new ChartPanel(chart) ;
    jpanel.add(BorderLayout.NORTH, chartPanel) ;
  }

  private static SingleRowDataset createDataset() {
    SingleRowDataset volumeDataset = new SingleRowDataset() ;
    volumeDataset.addRowKey("Volume") ;
    volumeDataset.addRowData() ;
    volumeDataset.addColKey("Normal") ;
    volumeDataset.addData(0, new StartEndNumberChartData(0.0D, 90D)) ;

    return volumeDataset ;
  }

}
