package demo.others.shapes ;

import java.awt.Color ;
import java.awt.Dimension ;
import java.awt.Graphics ;
import java.awt.Graphics2D ;
import java.awt.GridLayout ;
import java.awt.RenderingHints ;
import java.awt.event.MouseEvent ;
import java.awt.event.MouseMotionAdapter ;
import java.awt.geom.Ellipse2D ;
import java.awt.geom.Line2D ;
import java.awt.geom.Point2D ;
import java.util.HashMap ;
import java.util.Map ;

import javax.swing.BorderFactory ;
import javax.swing.JLabel ;
import javax.swing.JPanel ;

import com.ijchart.xychart.shape.DblHeadMatchstickChartShape ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class DblHeadMatchstickChartShapePanel extends JPanel {
  private Map hashMap = new HashMap() ;

  private JLabel label ;

  public DblHeadMatchstickChartShapePanel() {
    init() ;
  }

  private void init() {
    hashMap.put(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON) ;

    setLayout(new GridLayout(1, 2)) ;
    addPanel1() ;
    addPanel2() ;

    label = new JLabel("begin") ;
    add(label) ;
  }

  private void addPanel1() {
    final double size = 6.0 ;
    final double delta = -size / 2 ;
    final Ellipse2D ellipse = new Ellipse2D.Double(delta, delta, size, size) ;
    final Line2D line = new Line2D.Double(20, 20, 20, 50) ;

    final DblHeadMatchstickChartShape shape = new DblHeadMatchstickChartShape(ellipse, line) ;
    shape.setForceShowAllText(true) ;
    shape.setDrawBorder(true) ;
    shape.setFillShape(true) ;
    shape.setBorderPaint(Color.red) ;
    shape.setFillPaint(Color.red) ;

    JPanel panel = new JPanel() {
      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        g.drawRect(0, 0, 100, 100) ;

        shape.setFillShape(true) ;
        shape.setSelected(true) ;
        shape.draw((Graphics2D) g) ;

        Point2D p = shape.getLockPoint() ;
        g.fillRect((int) p.getX(), (int) p.getY(), 2, 2) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel2() {
    final double size = 6.0 ;
    final double delta = -size / 2 ;
    final Ellipse2D ellipse = new Ellipse2D.Double(delta, delta, size, size) ;
    final Line2D line = new Line2D.Double(20, 20, 60, 60) ;

    final DblHeadMatchstickChartShape shape = new DblHeadMatchstickChartShape(ellipse, line) ;
    shape.setDrawBorder(true) ;
    shape.setFillShape(true) ;
    shape.setBorderPaint(Color.red) ;
    shape.setFillPaint(Color.red) ;
    shape.setRotate(Math.PI / 8) ;

    JPanel panel = new JPanel() {
      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        g.drawRect(0, 0, 100, 100) ;

        shape.setFillShape(true) ;
        shape.setSelected(true) ;
        shape.draw((Graphics2D) g) ;

        Point2D p = shape.getLockPoint() ;
        g.setColor(Color.BLUE) ;
        g.fillRect((int) p.getX(), (int) p.getY(), 2, 2) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

}
