package demo.others.shapes;

import java.awt.Color ;
import java.awt.Dimension ;
import java.awt.Graphics ;
import java.awt.Graphics2D ;
import java.awt.GridLayout ;
import java.awt.RenderingHints ;
import java.awt.Shape ;
import java.awt.event.MouseEvent ;
import java.awt.event.MouseMotionAdapter ;
import java.awt.geom.Ellipse2D ;
import java.awt.geom.Rectangle2D ;
import java.util.HashMap ;
import java.util.Map ;

import javax.swing.JLabel ;
import javax.swing.JPanel ;

import com.ijchart.xychart.shape.RectangleTextChartShape ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class TooltipShapeTestPanel extends JPanel {
  private Map hashMap = new HashMap() ;

  private JLabel label ;

  public TooltipShapeTestPanel() {
    hashMap.put(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON) ;

    setLayout(new GridLayout(1, 2)) ;
    label = new JLabel("begin") ;
    add(label) ;

    addPanel1() ;
  }

  private void addPanel1() {
    final Shape tooltipShape = new Ellipse2D.Double(60, 60, 20, 20) ;
    final Rectangle2D rect = new Rectangle2D.Double(20, 20, 50, 50) ;
    final RectangleTextChartShape textShape = new RectangleTextChartShape(rect, "123") ;

    JPanel panel = new JPanel() {
      public void paint(Graphics g) {
        super.paintComponent(g) ;
        Graphics2D g2 = (Graphics2D) g ;
        g2.setRenderingHints(hashMap) ;

        setBackground(Color.white) ;

        textShape.setOriginTooltipShape(tooltipShape) ;
        textShape.setDrawBorder(true) ;
        textShape.draw(g2) ;
        textShape.setRotate(Math.PI / 12) ;

        Shape tooltipShape = textShape.getTooltipShape() ;
        g2.setPaint(Color.red) ;
        g2.draw(tooltipShape) ;
      }
    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {

      public void mouseMoved(MouseEvent e) {
        Shape tooltipShape = textShape.getTooltipShape() ;
        if (tooltipShape != null) {
          label.setText("(" + e.getX() + "," + e.getY() + ")"
                        + tooltipShape.contains(e.getX(), e.getY())) ;
        } else {
          label.setText("tooltip is null") ;
        }
      }
    }) ;

    panel.setPreferredSize(new Dimension(300, 300)) ;
    add(panel) ;
  }

}
