package demo.others.xy ;

import java.awt.GridLayout ;
import java.util.Calendar ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.IntervalXYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class IntervalXNumberBar2DChartPanelDay extends JPanel {
  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  public IntervalXNumberBar2DChartPanelDay() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;

//    setLayout(new GridLayout(2, 2)) ;
//    addPanel1() ;
//    addPanel2() ;
//    addPanel3() ;
//    addPanel4() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createIntervalXYBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, true, false) ;

//        setChartLabelXY(chart) ;
//        XYPlot plot = (XYPlot) chart.getPlot() ;
//        AbstractXYRender xyRender = plot.getRender() ;
//        xyRender.setRowItemsOutlineStroke(0, new BasicStroke(2.0F)) ;
//        xyRender.setRowItemsOutlineStroke(1, new BasicStroke(2.0F)) ;
//        xyRender.setBaseItemLabelFont(new Font("Dialog", 1, 14)) ;


  }

  private void addPanel2() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createIntervalXYBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, true, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
//        AbstractXYRender xyRender = plot.getRender() ;
//        xyRender.setRowItemsOutlineStroke(0, new BasicStroke(2.0F)) ;
//        xyRender.setRowItemsOutlineStroke(1, new BasicStroke(2.0F)) ;
//        xyRender.setBaseItemLabelFont(new Font("Dialog", 1, 14)) ;
//
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;
//        valueAxis.setLowerMargin(0.05) ;
//        valueAxis.setUpperMargin(0.05) ;
//        setChartLabelXY(chart) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel3() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createIntervalXYBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true, true, false) ;

//        setChartLabelXY(chart) ;
//        XYPlot plot = (XYPlot) chart.getPlot() ;
//        AbstractXYRender xyRender = plot.getRender() ;
//        xyRender.setRowItemsOutlineStroke(0, new BasicStroke(1.5F)) ;
//        xyRender.setRowItemsOutlineStroke(1, new BasicStroke(2.5F)) ;
//
//        AbstractValueAxis valueAxis = plot.getValueAxis() ;
//        valueAxis.setLowerMargin(0.05) ;
//        valueAxis.setUpperMargin(0.05) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel4() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createIntervalXYBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true, true, false) ;

//        setChartLabelXY(chart) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
//        AbstractXYRender xyRender = plot.getRender() ;
//        xyRender.setRowItemsOutlineStroke(0, new BasicStroke(1.0F)) ;
//        xyRender.setRowItemsOutlineStroke(1, new BasicStroke(4.0F)) ;
//
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;
//        valueAxis.setLowerMargin(0.05) ;
//        valueAxis.setUpperMargin(0.05) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;

    dataset.addRowKey("Row1") ;
    dataset.addRowKey("Row2") ;
    dataset.addRowKey("Row3") ;

    Calendar day = createCalendar(12, 6, 2007) ;
    Calendar day1 = createCalendar(13, 6, 2007) ;
    Calendar day2 = createCalendar(14, 6, 2007) ;
    Calendar day3 = createCalendar(15, 6, 2007) ;
    Calendar day4 = createCalendar(16, 6, 2007) ;
    Calendar day5 = createCalendar(17, 6, 2007) ;

    dataset.addRowData() ;
    dataset.addData(0, createData(day, day1, 1, 2)) ;
    dataset.addData(0, createData(day3, day4, 1, 2)) ;

    dataset.addRowData() ;
    dataset.addData(1, createData(day, day5, 4, 5)) ;

    dataset.addRowData() ;
    dataset.addData(2, createData(day2, day4, 7, 8)) ;

    return dataset ;
  }

  private Calendar createCalendar(int day, int month, int year) {
    Calendar cal = Calendar.getInstance() ;
    cal.set(year, month - 1, day, 0, 0, 0) ;
    cal.set(Calendar.MILLISECOND, 0) ;

    return cal ;
  }

  private static IntervalXYNumberChartData createData(Calendar calStart, Calendar calEnd,
                                                      double startValue, double endValue) {
    long start = calStart.getTime().getTime() ;
    long end = calEnd.getTime().getTime() ;

    return new IntervalXYNumberChartData(start, end, startValue, endValue) ;
  }

}
