package demo.others.xy ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.ErrorChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYErrorRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class XYErrorChartPanel3 extends JPanel {

  public XYErrorChartPanel3() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createXYErrorChart("XY Error Demo 1", "X", "Y", dataset,
                                                    ChartOrientation.VERTICAL, true, true, false, false) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    XYErrorRender render = (XYErrorRender) plot.getRender() ;
    render.setDrawYError(false) ;
    render.setCapLength(8) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;
    dataset.addRowKey("Series 2") ;
    dataset.addRowData(2) ;

    dataset.addData(0, new ErrorChartData(1.0D, 0.5D, 1.5D, 10D, 9D, 11D)) ;
    dataset.addData(0, new ErrorChartData(10D, 8.6999999999999993D, 11.210000000000001D,
                                          6.0999999999999996D, 4.3399999999999999D, 7.54D)) ;
    dataset.addData(0, new ErrorChartData(17.800000000000001D, 16D, 18.899999999999999D,
                                          4.5D, 3.1000000000000001D, 5.7999999999999998D)) ;

    dataset.addData(1, new ErrorChartData(3D, 2.5D, 3.5D, 7D, 6D, 8D)) ;
    dataset.addData(1, new ErrorChartData(13D, 11.5D, 14.5D, 13D, 11.5D, 14.5D)) ;
    dataset.addData(1, new ErrorChartData(24D, 22.699999999999999D, 25.210000000000001D,
                                          16.100000000000001D, 14.34D, 17.539999999999999D)) ;

    return dataset ;
  }

}
