package demo.stackedbarcharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.Stacked3DNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.tickunit.LongTickUnit ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class StackedBarChart3DDemo5 extends JPanel {

  public StackedBarChart3DDemo5() {
    setLayout(new GridLayout(2, 2)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IJChart chart1 = createChart(1, ChartOrientation.VERTICAL) ;
    ChartPanel chartpanel = new ChartPanel(chart1) ;
    add(chartpanel) ;

    IJChart chart2 = createChart(2, ChartOrientation.VERTICAL) ;
    ((CategoryPlot) chart2.getPlot()).getValueAxis().setInverted(true) ;
    ChartPanel chartpanel2 = new ChartPanel(chart2) ;
    add(chartpanel2) ;

    IJChart chart3 = createChart(3, ChartOrientation.HORIZONTAL) ;
    ((CategoryPlot) chart3.getPlot()).getValueAxis().setInverted(true) ;
    ChartPanel chartpanel3 = new ChartPanel(chart3) ;
    add(chartpanel3) ;

    IJChart chart4 = createChart(4, ChartOrientation.HORIZONTAL) ;
    ChartPanel chartpanel4 = new ChartPanel(chart4) ;
    add(chartpanel4) ;
  }

  private static IJChart createChart(int i, ChartOrientation orientation) {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createStackedBar3DChart("Chart " + i, "Category",
                                                         "Value", dataset, orientation,
                                                         false, true) ;
    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    Stacked3DNumberValueAxis valueAxis = (Stacked3DNumberValueAxis) plot.getValueAxis() ;
    valueAxis.setTickUnit(new LongTickUnit()) ;

    return chart ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("Series 1") ;
    dataset.addColKey("Series 2") ;
    dataset.addColKey("Series 3") ;

    for (int i = 1 ; i <= 4 ; i++) {
      dataset.addRowKey("Category" + i) ;
    }

    double data1[] = {1.0D, 2D, 1.5D, 1.5D} ;
    double data2[] = { -1D, -1.8999999999999999D, -1.5D, -1.5D} ;
    double data3[] = {1.0D, 1.8999999999999999D, 1.5D, 1.5D} ;

    dataset.addRowData(data1.length) ;
    for (int i = 0 ; i < data1.length ; i++) {
      dataset.addData(i, new NumberChartData(data1[i])) ;
      dataset.addData(i, new NumberChartData(data2[i])) ;
      dataset.addData(i, new NumberChartData(data3[i])) ;
    }

    return dataset ;
  }

}
