package com.ijchart.xychart.constant ;

import java.io.Serializable ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>Gradient Paintı任</zh>
 * <en>Represents a type of transform for a GradientPaint</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class GradientPaintTransformType implements Serializable {

  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization</en>
   */
  private static final long serialVersionUID = 8331561784933982450L ;

  /**
   * <zh>ֱչ.</zh>
   * <en>Vertical.</en>
   */
  public static final GradientPaintTransformType VERTICAL =
    new GradientPaintTransformType("GradientPaintTransformType.VERTICAL") ;

  /**
   * <zh>ˮƽչ.</zh>
   * <en>Horizontal.</en>
   */
  public static final GradientPaintTransformType HORIZONTAL
    = new GradientPaintTransformType("GradientPaintTransformType.HORIZONTAL") ;

  /**
   * <zh>мֱչ.</zh>
   * <en>Center/vertical.</en>
   */
  public static final GradientPaintTransformType CENTER_VERTICAL
    = new GradientPaintTransformType("GradientPaintTransformType.CENTER_VERTICAL") ;

  /**
   * <zh>мˮƽչ.</zh>
   * <en>Center/horizontal.</en>
   */
  public static final GradientPaintTransformType CENTER_HORIZONTAL
    = new GradientPaintTransformType("GradientPaintTransformType.CENTER_HORIZONTAL") ;

  /**
   * <zh>Gradient Paint չ.</zh>
   * <en>The Gradient Paint transform name.</en>
   */
  private String name ;

  /**
   * Private constructor
   *
   * @param name <zh>.</zh>
   * <en>The name.</en>
   */
  private GradientPaintTransformType(String name) {
    this.name = name ;
  }

  /**
   * Returns a string representing the object
   *
   * @return The string.
   */
  public String toString() {
    return this.name ;
  }

  /**
   * Returns true if this object is equal to the specified object, and false otherwise
   *
   * @param o  the other object.
   * @return A boolean.
   */
  public boolean equals(final Object o) {
    if (this == o) {
      return true ;
    }
    if (!(o instanceof GradientPaintTransformType)) {
      return false ;
    }

    GradientPaintTransformType t = (GradientPaintTransformType) o ;
    if (!this.name.equals(t.name)) {
      return false ;
    }

    return true ;
  }

  /**
   * Returns a hash code value for the object
   *
   * @return the hashcode
   */
  public int hashCode() {
    return this.name.hashCode() ;
  }
}
