package com.ijchart.xychart.constant ;

import java.io.Serializable ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ȵ,չ,С,ޱ仯.</zh>
 * <en> Represents the three options for adjusting a length:  expand, contract, and no change.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class LengthAdjustmentType implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = 3137690103548361159L ;

  /**
   * <zh>ޱ仯.</zh>
   * <en>No change.</en>
   */
  public static final LengthAdjustmentType NO_CHANGE = new LengthAdjustmentType(
    "LengthAdjustmentType.NO_CHANGE") ;

  /** EXPAND. */
  /**
   * <zh>չ.</zh>
   * <en>Expand.</en>
   */
  public static final LengthAdjustmentType EXPAND = new LengthAdjustmentType(
    "LengthAdjustmentType.EXPAND") ;

  /**
   * <zh>С.</zh>
   * <en>Contract.</en>
   */
  public static final LengthAdjustmentType CONTRACT = new LengthAdjustmentType(
    "LengthAdjustmentType.CONTRACT") ;

  /**
   * <zh>.</zh>
   * <en>The name.</en>
   */
  private String name ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   *
   * @param name String <zh>.</zh>
   * <en>The name.</en>
   */
  private LengthAdjustmentType(final String name) {
    this.name = name ;
  }

  /**
   * <zh>toString.</zh>
   * <en>Returns a string representing the object.</en>
   *
   * @return The string.
   */
  public String toString() {
    return this.name ;
  }

  /**
   * <zh>equals.</zh>
   * <en>Returns true if this object is equal to the specified object, and false otherwise.</en>
   *
   * @param obj  the other object (null permitted).
   * @return A boolean.
   */
  public boolean equals(final Object obj) {
    if (obj == this) {
      return true ;
    }
    if (!(obj instanceof LengthAdjustmentType)) {
      return false ;
    }

    LengthAdjustmentType that = (LengthAdjustmentType) obj ;
    return this.name.equals(that.name) ;
  }

  /**
   * <zh>hashcode.</zh>
   * <en>Returns a hash code value for the object.</en>
   *
   * @return The hashcode
   */
  public int hashCode() {
    return this.name.hashCode() ;
  }

}
