package com.ijchart.xychart.constant ;

import java.io.Serializable ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ͳ,.</zh>
 * <en>Define the type of a sort, ascending or descending.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class SortType implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = 7892514112204080184L ;

  /**
   * <zh>.</zh>
   * <en>Ascending.</en>
   */
  public static final SortType ASCENDING = new SortType("SortType.Ascending") ;

  /**
   * <zh>.</zh>
   * <en>Descending.</en>
   */
  public static final SortType DESCENDING = new SortType("SortType.Descending") ;

  /**
   * <zh>.</zh>
   * <en>The name.</en>
   */
  private String name ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   *
   * @param name <zh>.</zh>
   * <en>The name.</en>
   */
  private SortType(String name) {
    this.name = name ;
  }

  /**
   * <zh>equals.</zh>
   * <en>Override equals method.</en>
   * @param obj Object
   * @return boolean
   */
  public boolean equals(Object obj) {
    if (this == obj) {
      return true ;
    }

    if (!(obj instanceof SortType)) {
      return false ;
    }

    SortType tmp = (SortType) obj ;

    return this.name.equals(tmp.name) ;
  }

  /**
   * <zh>toString().</zh>
   * <en>Override toString method.</en>
   * @return String
   */
  public String toString() {
    return "[name=" + name + "]" ;
  }

  /**
   * <zh>hashcodeֵ.</zh>
   * <en>Returns a hash code value for the object. </en>
   * @return  a hash code value for this object.
   */
  public int hashCode() {
    return (this.name == null) ? 0 : this.name.hashCode() ;
  }

}
