package com.ijchart.xychart.listener ;

import java.util.EventListener ;

import com.ijchart.xychart.event.MarkerChangeEvent ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>¼ڼͼmarker仯ʱ¼,¼ʱʵִ˼ᱻԶ֪ͨ.</zh>
 * <en> The interface that must be supported by classes that wish to receive
 * notification of changes to a marker.
 * <P>
 * The Plot class implements this interface, and automatically registers with
 * its marker (if any). Any marker changes are passed on by the plot as a plot
 * change event.  This is part of the notification mechanism that ensures that
 * charts are redrawn whenever changes are made to any chart component.
 * </en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public interface IMarkerChangeListener extends EventListener {

  /**
   * <zh>յmarker仯¼.</zh>
   * <en>Receives notification of an marker change event.</en>
   *
   * @param event MarkerChangeEvent <zh>marker仯¼.</zh>
   * <en>The marker change event.</en>
   */
  void markerChanged(MarkerChangeEvent event) ;

}
