package com.ijchart.xychart.render ;

import java.awt.geom.Rectangle2D ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.chartinfo.RenderShapeCollection ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.ValueAxisOffsetType ;
import com.ijchart.xychart.ui.RectangleEdge ;

/**
 * <p>Title: IJChart</p>
 * <zh>chartrenderķ.</zh>
 * <en>Base interface providing common services for renders with axis.</en>
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public interface IRenderWithAxis extends IRender {
  /**
   * <zh>ƫ.</zh>
   * <en>The value axis offset type.</en>
   *
   * @return ValueAxisOffsetType <zh>ƫ (Ϊnull).</zh>
   * <en>The axis offset type (possibly null).</en>
   */
  ValueAxisOffsetType getValueAxisOffsetType() ;

  /**
   * <zh>value marker.</zh>
   * <en>Draws a marker to indicate a particular value on the value axis.</en>
   *
   * @param valueAxis AbstractValueAxis <zh>value (Ϊnull).</zh>
   * <en>The value axis (null not permitted).</en>
   * @param yAxis boolean <zh>Ƿy.</zh>
   * <en>Whether or not is y axis.</en>
   * @param axisEdge RectangleEdge <zh>λ (Ϊnull).</zh>
   * <en>The axis position (null not permitted).</en>
   * @param dataArea Rectangle2D <zh> (Ϊnull).</zh>
   * <en>The chart data area (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ (Ϊnull).</zh>
   * <en>The chart orientation (null not permitted).</en>
   * @param renderShapes RenderShapeCollection <zh>renderͼμ (Ϊnull).</zh>
   * <en>Collects information about the render (null not permitted).</en>
   */
  void drawValueMarker(AbstractValueAxis valueAxis, boolean yAxis, RectangleEdge axisEdge,
                       Rectangle2D dataArea, ChartOrientation orientation,
                       RenderShapeCollection renderShapes) ;

  /**
   * <zh>value marker.</zh>
   * <en>Draws a marker to indicate a particular value on the value axis.</en>
   *
   * @param valueAxis AbstractValueAxis <zh>value (Ϊnull).</zh>
   * <en>The value axis (null not permitted).</en>
   * @param yAxis boolean <zh>Ƿy.</zh>
   * <en>Whether or not is y axis.</en>
   * @param axisEdge RectangleEdge <zh>λ (Ϊnull).</zh>
   * <en>The axis position (null not permitted).</en>
   * @param dataArea Rectangle2D <zh> (Ϊnull).</zh>
   * <en>The chart data area (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ (Ϊnull).</zh>
   * <en>The chart orientation (null not permitted).</en>
   * @param renderShapes RenderShapeCollection <zh>renderͼμ (Ϊnull).</zh>
   * <en>Collects information about the render (null not permitted).</en>
   */
  void drawIntervalValueMarker(AbstractValueAxis valueAxis, boolean yAxis, RectangleEdge axisEdge,
                               Rectangle2D dataArea, ChartOrientation orientation,
                               RenderShapeCollection renderShapes) ;

}
