package com.ijchart.xychart.shape.change ;

import java.awt.Graphics2D ;

import com.ijchart.xychart.shape.IChartShape ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>{@link IShapeChange}.</zh>
 * <en>The adapter class for {@link IShapeChange}</en>
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public abstract class AbstractShapeChangeAdapter {
  /**
   * <zh>{@link IChartShape}draw֮ǰ.</zh>
   * <en>Called at the begin of {@link IChartShape}.draw method.</en>
   *
   * @param shape IChartShape <zh>IChartShape (Ϊnull).</zh>
   * <en>The IChartShape object (null not permitted).</en>
   * @param g2 Graphics2D <zh>ͼ豸(Ļӡ) (Ϊnull).</zh>
   * <en>The graphics device (such as the screen or the printer) (null not permitted).</en>
   */
  public void beforeDraw(IChartShape shape, Graphics2D g2) {

  }

  /**
   * <zh>{@link IChartShape}draw֮.</zh>
   * <en>Called at the end of {@link IChartShape}.draw method.</en>
   *
   * @param shape IChartShape <zh>IChartShape (Ϊnull).</zh>
   * <en>The IChartShape object (null not permitted).</en>
   * @param g2 Graphics2D <zh>ͼ豸(Ļӡ) (Ϊnull)</zh>
   * <en>The graphics device (such as the screen or the printer) (null not permitted).</en>
   */
  public void afterDraw(IChartShape shape, Graphics2D g2) {

  }

}
