package com.ijchart.xychart.title ;

import java.awt.Graphics2D ;
import java.awt.geom.Rectangle2D ;

import com.ijchart.xychart.chartinfo.ChartShapeCollection ;
import com.ijchart.xychart.ui.Rectangle ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ڻͼеıⲿ,͵ıⶼҪʵִ˽ӿ.</zh>
 * <en>Interface for draw title on chart,all types of title should implement this interface.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public interface ITitle {
  /**
   * <zh>ͼchartAreaƱⲿ.ͼеͼδshapeCollection.</zh>
   * <en>Draw the title on chart area(chartArea).All title shape is stored in shapeCollection.</en>
   *
   * @param g2 Graphics2D <zh>ͼ豸(ӡĻ) (Ϊnull).</zh>
   * <en>The graphics device (null not permitted).</en>
   * @param chartArea Rectangle2D <zh>ͼ.</zh>
   * <en>The area within which the chart should be drawn.</en>
   * @param shapeCollection ChartShapeCollection <zh>ͼͼμ.</zh>
   * <en>Collects information about the plot (null permitted).</en>
   *
   * @return Rectangle <zh>.</zh>
   * <en>The area within which the title should be drawn.</en>
   */
  Rectangle draw(Graphics2D g2, Rectangle2D chartArea, ChartShapeCollection shapeCollection) ;
}
